import { defineConfig } from 'dumi';
import path from 'path';

export default defineConfig({
  logo: '/logo.jpg',
  favicons: ['/logo.jpg'],
  history: { type: 'hash' },
  themeConfig: {
    name: 'zhst前端库',
  },
  alias: {
    '@zhst/hooks': path.join(__dirname, 'packages/hooks/src'),
    '@zhst/func': path.join(__dirname, 'packages/func/src'),
    '@zhst/biz': path.join(__dirname, 'packages/biz/src'),
    '@zhst/meta': path.join(__dirname, 'packages/meta/src'),
  },
  resolve: {
    docDirs: ['docs'],
    atomDirs: [
      { type: 'hooks', dir: 'packages/hooks/src' },
      { type: 'utils', dir: 'packages/func/src' },
      { type: 'biz', dir: 'packages/biz/src' },
      { type: 'meta', dir: 'packages/meta/src' },
    ],
  },
  monorepoRedirect: {
    srcDir: ['packages', 'src'],
    peerDeps: true,
  },
  extraBabelPlugins: [
    [
      'import',
      {
        libraryName: 'antd',
        libraryDirectory: 'es',
        style: true,
      },
    ],
  ],
});
