---
nav:
  title: 业务组件
group:
  title: 数据展示
  order: 1
---


# 大图弹框

```jsx
import React from 'react';
import { Button } from 'antd'
import { BigImageModal } from '@zhst/biz'
import { DescriptionsProps } from '@zhst/biz'
import { IMAGE_DATA } from './mock.ts'

const descriptionList: DescriptionsProps['items'] = [
  {
    title: '人员属性',
    children: [
      {
        key: '1',
        label: '性别',
        children: '男',
      },
      {
        key: '2',
        label: '年龄',
        children: '成年',
      },
      {
        key: '3',
        label: '帽子',
        children: '无',
      },
      {
        key: '4',
        label: '上身颜色',
        children: '灰',
      },
      {
        key: '5',
        label: '下身颜色',
        children: '蓝色',
      },
      {
        key: '6',
        label: '附着物',
        children: '无',
      },
      {
        key: '7',
        label: '骑行',
        children: '否',
      },
    ]
  }
];

export default () => {
  console.log(IMAGE_DATA)
  
  return (
    <BigImageModal 
      title="查看大图" 
      open 
      dataSource={IMAGE_DATA.dataSource}
      imageData={IMAGE_DATA.dataSource}
      width={1098}
      descriptionConfig={{ data: descriptionList }}
    />
  )
}
```
