/**
 * 获取经纬信息
 * @param lngLat 位置信息
 * @returns @object { long, lat }
 */
export var fixedLngLat = function fixedLngLat(lngLat) {
  if (!lngLat) {
    return '';
  }
  var lngLatArr = lngLat.split(',');
  var longitude = Number(lngLatArr[0]).toFixed(6);
  var latitude = Number(lngLatArr[1]).toFixed(6);
  if (lngLatArr.length < 2) {
    return '';
  }
  return "".concat(longitude, ",").concat(latitude);
};
export var transformLngLat = function transformLngLat(lngLat) {
  if (lngLat) {
    var lngLatArr = lngLat ? lngLat.split(',') : [];
    var longitude = Number(lngLatArr[0]);
    var latitude = Number(lngLatArr[1]);
    if (lngLatArr.length < 2) {
      return null;
    }
    return {
      longitude: longitude,
      latitude: latitude
    };
  }
  return null;
};