import { DevicemanagerCameraType } from './constants';
export declare const isFaceCamera: (type: DevicemanagerCameraType) => boolean;
/**
 *
 * @param value 传入的数据 可以是 item（camera/vms/dirs）/ deviceID
 * @param isId
 */
export declare function getDeviceType(value: {
    [x: string]: any;
    id: any;
} | string): any;
/**
 * 后端设备id/vmsid/dirid是三张表 合并在一起不保证唯一 前端生成唯一key
 * @param id  设备id
 * @param type  设备类型
 */
export declare function deviceIDToDeviceKey(id: any, type: string, vmsId?: any): string;
/**
 * 后端设备id/vmsid/dirid是三张表 合并在一起不保证唯一 前端生成唯一key
 * @param item  camera/vms/dirs
 */
export declare function deviceToDeviceKey(item: {
    [x: string]: any;
    id: any;
}): string;
/**
 * 设备树key 转 后端设备原始id dirid是string/vms&camera 是number 和后端保持一致
 * @param deviceKey 设备树的id
 */
export declare function deviceKeyToDeviceId(deviceKey: {
    split: (arg0: string) => [any, any];
}): any;
export declare const getVmsIdByDeviceId: (key: string) => string;
/**
 * 通过设备id或设备key在树里面找摄像头
 * @param ids cameraId
 * @param deviceTree 树
 * @param type "id" | "key"
 */
export declare const findCamerasByInDeviceTree: (ids: never[] | undefined, deviceTree: any, type?: string) => any[];
