
/**
 * 设置数据的精度
 * @param originNumber
 * @param accuracy 精度 以原点为中心向左为正，向右为负，
 * @param isCeil 是否为向上取整
 * @returns number
 */
export const setNumberAccuracy = (originNumber: number, accuracy = 0, isCeil = true) => {
  if (originNumber === 0) {
    return 0;
  }
  let returnData = 0;

  if (isCeil) {
    returnData = Math.ceil(originNumber / Math.pow(10, accuracy)) * Math.pow(10, accuracy);
  } else {
    returnData = Math.floor(originNumber / Math.pow(10, accuracy)) * Math.pow(10, accuracy);
  }
  //设置精度
  if (accuracy < 0) {
    returnData = Number(returnData.toFixed(-accuracy));
  } else {
    returnData = Number(returnData.toFixed(0));
  }
  return returnData;
};
