function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { useLatest } from 'ahooks';
import events from 'events';
import { get, isArray } from '@zhst/func';
import { useEffect } from 'react';
import { useLocation, useNavigate } from 'react-router-dom';
import { JumpKey } from "./constants";
var emitter = new events.EventEmitter();
var useJump = function useJump() {
  var location = useLocation();
  var navigate = useNavigate();
  var jump = function jump(path, data) {
    if (location.pathname !== path) {
      navigate(path, {
        state: {
          data: data,
          topic: JumpKey,
          __from__: location.pathname
        }
      });
    } else {
      emitter.emit(JumpKey, data);
    }
  };
  return jump;
};
export var useListenJump = function useListenJump(handle, type) {
  var latestHandle = useLatest(handle);
  var navigate = useNavigate();
  var _type = isArray(type) ? type : [type];
  var location = useLocation();
  useEffect(function () {
    var state = location.state,
      pathname = location.pathname,
      search = location.search;
    if (state) {
      var topic = state.topic,
        _data = state.data,
        __from__ = state.__from__;
      if (topic === JumpKey && _type.includes(get(_data, '__key__'))) {
        latestHandle.current(_objectSpread(_objectSpread({}, _data), {}, {
          __from__: __from__
        }));
      }
      navigate("/".concat(pathname).concat(search), {
        state: null
      });
    }
  }, [location]);
  useEffect(function () {
    var handleEmit = function handleEmit(data) {
      if (_type.includes(get(data, '__key__'))) {
        latestHandle.current(data);
      }
    };
    emitter.on(JumpKey, handleEmit);
    return function () {
      emitter.removeListener(JumpKey, handleEmit);
    };
  }, []);
};
export default useJump;