var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/useRafLoop.ts
var useRafLoop_exports = {};
__export(useRafLoop_exports, {
  default: () => useRafLoop
});
module.exports = __toCommonJS(useRafLoop_exports);
var import_react = require("react");
function useRafLoop(callback, initiallyActive = true) {
  const raf = (0, import_react.useRef)(null);
  const rafActivity = (0, import_react.useRef)(false);
  const rafCallback = (0, import_react.useRef)(callback);
  rafCallback.current = callback;
  const step = (0, import_react.useCallback)((time) => {
    if (rafActivity.current) {
      rafCallback.current(time);
      raf.current = requestAnimationFrame(step);
    }
  }, []);
  const result = (0, import_react.useMemo)(
    () => [
      () => {
        if (rafActivity.current) {
          rafActivity.current = false;
          raf.current && cancelAnimationFrame(raf.current);
        }
      },
      () => {
        if (!rafActivity.current) {
          rafActivity.current = true;
          raf.current = requestAnimationFrame(step);
        }
      },
      () => rafActivity.current
      // isActive
    ],
    []
  );
  (0, import_react.useEffect)(() => {
    if (initiallyActive) {
      result[1]();
    }
    return result[0];
  }, []);
  return result;
}
