//对生成的值做深比较
import { useState, useMemo, DependencyList } from 'react';
import useDeepEffect from '../useDeepEffect';

export default function useDeepMemo<T>(factory: () => T, deps: DependencyList | undefined) {
  const value = useMemo(factory, deps);
  const [state, setState] = useState(value);
  useDeepEffect(() => {
    setState(value);
  }, [value]);

  return state;
}
