//@ts-nocheck
import { IS_TOUCH_DEVICE, HAS_POINTER_EVENT } from "../utils";
export var NAMESPACE = 'zhst-cropper';

// Actions
export var ACTION_MOVE = 'move';
export var ACTION_CROP = 'crop';
export var ACTION_EAST = 'e';
export var ACTION_WEST = 'w';
export var ACTION_SOUTH = 's';
export var ACTION_NORTH = 'n';
export var ACTION_NORTH_EAST = 'ne';
export var ACTION_NORTH_WEST = 'nw';
export var ACTION_SOUTH_EAST = 'se';
export var ACTION_SOUTH_WEST = 'sw';

// Classes
export var CLASS_HIDDEN = "".concat(NAMESPACE, "-hidden");
export var CLASS_MASK = "".concat(NAMESPACE, "-mask");

// Data keys
export var DATA_ACTION = "".concat(NAMESPACE, "-action");

// Events
export var EVENT_TOUCH_START = IS_TOUCH_DEVICE ? 'touchstart' : 'mousedown';
export var EVENT_TOUCH_MOVE = IS_TOUCH_DEVICE ? 'touchmove' : 'mousemove';
export var EVENT_TOUCH_END = IS_TOUCH_DEVICE ? 'touchend touchcancel' : 'mouseup';
export var EVENT_POINTER_DOWN = HAS_POINTER_EVENT ? 'pointerdown' : EVENT_TOUCH_START;
export var EVENT_POINTER_MOVE = HAS_POINTER_EVENT ? 'pointermove' : EVENT_TOUCH_MOVE;
export var EVENT_POINTER_UP = HAS_POINTER_EVENT ? 'pointerup pointercancel' : EVENT_TOUCH_END;
export var EVENT_WHEEL = 'wheel';

//custom event
export var EVENT_CROP_CHANGE = 'crop-change';
export var EVENT_CROP_START = 'crop-start';
export var EVENT_CROP_END = 'crop-end';

// RegExps
export var REGEXP_SPACES = /\s\s*/;
export var REGEXP_ACTIONS = /^e|w|s|n|se|sw|ne|nw|all|crop|move|zoom$/;