import { IS_TOUCH_DEVICE, HAS_POINTER_EVENT } from "../utils";
export var NAMESPACE = 'zhst-viewer';

// Actions
export var ACTION_DRAG = 'drag';

// Classes
export var CLASS_CANVAS = "".concat(NAMESPACE, "-canvas");
export var CLASS_MOVE = "".concat(NAMESPACE, "-move");

// Events
export var EVENT_CLICK = 'click';
export var EVENT_TOUCH_START = IS_TOUCH_DEVICE ? 'touchstart' : 'mousedown';
export var EVENT_TOUCH_MOVE = IS_TOUCH_DEVICE ? 'touchmove' : 'mousemove';
export var EVENT_TOUCH_END = IS_TOUCH_DEVICE ? 'touchend touchcancel' : 'mouseup';
export var EVENT_POINTER_DOWN = HAS_POINTER_EVENT ? 'pointerdown' : EVENT_TOUCH_START;
export var EVENT_POINTER_MOVE = HAS_POINTER_EVENT ? 'pointermove' : EVENT_TOUCH_MOVE;
export var EVENT_POINTER_UP = HAS_POINTER_EVENT ? 'pointerup pointercancel' : EVENT_TOUCH_END;
export var EVENT_WHEEL = 'wheel';
export var EVENT_LEAVEL = 'mouseleave';
export var EVENT_ENTER = 'mouseenter';
//custom event
export var EVENT_VIEWER_TRANSFORM_CHANGE = 'viewer-transform-change';
export var EVENT_VIEWER_READY = 'viewer-ready';
export var EVENT_VIEWER_ERROR = 'viewer-error';
export var EVENT_SHAPE_SELECT = 'shape-select';
export var EVENT_EYE_DONE = 'eye-done';

// RegExps
export var REGEXP_SPACES = /\s\s*/;

//变换前的坐标（左上角为原点）
export var AXIS_TYPE_ORIGIN = 1;
//变换后显示在画布中的坐标（还是左上角为原点）
export var AXIS_TYPE_CANVAS = 2;
//基于图片的坐标轴 原点为图片左上角
export var AXIS_TYPE_IMAGE = 3;

//形状
export var SHAPE_TYPE_CUSTOM = 1;
export var SHAPE_TYPE_RECT = 2;
export var SHAPE_TYPE_CIRCLE = 3;