var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};

// src/ImageEditor/cropper/index.ts
var cropper_exports = {};
__export(cropper_exports, {
  default: () => cropper_default
});
module.exports = __toCommonJS(cropper_exports);
var import_func = require("@zhst/func");
var import_class = require("rc-util/lib/Dom/class");
var import_utils = require("../utils");
var import_constants = require("./constants");
var import_template = __toESM(require("./template"));
var import_render = __toESM(require("./render"));
var import_event = __toESM(require("./event"));
var import_viewerBridge = __toESM(require("./viewerBridge"));
var import_preview = __toESM(require("./preview"));
var import_index_module = require("./index.module.scss");
var Cropper = class {
  constructor(element, options) {
    /* 所有事件 */
    // eventHandleList: Array<any>;
    this.eventHandleList = [];
    this.element = element;
    this.options = Object.assign({}, (0, import_func.isPlainObject)(options) && options);
    this.limited = (0, import_func.isNil)(this.options.cropBoxLimited) ? false : true;
    this.cropped = false;
    this.init();
  }
  async init() {
    this.build();
    this.bind();
    this.render();
    this.initPreview();
    if (this.options.viewer) {
      this.initBridge();
    }
    this.initDefaultCropBox();
  }
  initDefaultCropBox() {
    const { initialCropBoxData } = this.options || {};
    if (initialCropBoxData) {
      this.cropped = true;
      const { showMask } = this.options;
      showMask && (0, import_class.addClass)(this.dragBox, import_constants.CLASS_MASK);
      (0, import_class.removeClass)(this.cropBox, import_constants.CLASS_HIDDEN);
      this.cropBoxData = { ...this.cropBoxData, ...initialCropBoxData };
      this.renderCropBox();
      const hasCrop = (0, import_func.get)(this, "cropBoxData.width", 0) !== 0 && (0, import_func.get)(this, "cropBoxData.height", 0) !== 0;
      (0, import_utils.dispatchEvent)(this.element, import_constants.EVENT_CROP_CHANGE, hasCrop ? this == null ? void 0 : this.cropBoxData : null);
      hasCrop && (0, import_utils.dispatchEvent)(this.element, import_constants.EVENT_CROP_END, hasCrop ? this == null ? void 0 : this.cropBoxData : null);
    }
  }
  load() {
    return new Promise((resolve, reject) => {
      const { image: propImage } = this.options;
      if ((0, import_func.isString)(propImage)) {
        const image = new Image();
        const imgUrl = propImage;
        image.crossOrigin = "anonymous";
        image.src = imgUrl;
        image.onload = () => {
          this.image = image;
          resolve(image);
        };
        image.onerror = (err) => {
          reject(err);
        };
      } else {
        this.image = propImage;
        resolve(propImage);
      }
    });
  }
  build() {
    const template = document.createElement("div");
    template.innerHTML = import_template.default;
    const container = template.querySelector(`.${import_constants.NAMESPACE}-container`);
    const dragBox = container.querySelector(`.${import_constants.NAMESPACE}-drag-box`);
    const cropBox = container.querySelector(`.${import_constants.NAMESPACE}-crop-box`);
    const viewBox = container.querySelector(`.${import_constants.NAMESPACE}-view-box`);
    this.element.appendChild(container);
    this.container = container;
    this.dragBox = dragBox;
    this.cropBox = cropBox;
    this.viewBox = viewBox;
    (0, import_class.addClass)(cropBox, import_constants.CLASS_HIDDEN);
  }
  destroy() {
    var _a, _b;
    if (this.options.viewer) {
      this.clearBridge();
    }
    this.unbind();
    (_b = (_a = this.element) == null ? void 0 : _a.removeChild) == null ? void 0 : _b.call(_a, this.container);
  }
};
Cropper = __decorateClass([
  (0, import_utils.Mixin)(import_render.default, import_event.default, import_viewerBridge.default, import_preview.default)
], Cropper);
var cropper_default = Cropper;
